--------------------------------------------------------
-- panel3Box.lua
-- Edit by Lygin Gennady a.k.a Croc 17.08.2016
--------------------------------------------------------
require "locale";
require "closeButton";
----------------------------------------------
-- Set initial values
----------------------------------------------
local newwidth, newheight;
local gn=10
local gg=gn-1
local panel3FrameWidth, panel3FrameHeight = 186, 17*gn+3;
width, height              = celestia:getscreendimension();
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
panel3Box = CXBox:new()    
    --:bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :init(0, 0, 0, 0)
    :movable(false)
    :attach(screenBox, width, height, 0, 0);

-----------------------------------------------
panel3Frame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.8}) 
    :fillcolor(csetbofill)
    :textfont(normalfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("center")
    :movetext(0, 5)
    :active(false)
    :text(_("Coordinates. Options settings:")) 
    :movable(true)
    :clickable(false)    
    :visible(false)
    :attach(screenBox, (width-panel3FrameWidth)/2, height-panel3FrameHeight-2, (width-panel3FrameWidth)/2, 2)

closepanel3Button = CXBox:new()
        :init(0, 0, 0, 0) 
       -- :bordercolor(cbubordoff)      
        :textfont(smallfont)
        :textcolor({1,0,0,0.5})
        :textpos("left")
        :movetext(1, 12)
        :text("x")
        :movable(false)
        :active(true)
        :attach(panel3Frame, 172, 160, 2, 2);

    closepanel3Button.Action = (function()
        return
            function()   
             display_panel3 = not display_panel3;
                if panel3Frame.Visible then                   
                    panel3Frame.Visible = false; 
                    panel3Check.Text = "o";                                
                    panel3Check.Text = "";             
                end             
           end
      end) ();

panel3Frame.Customdraw = function(this)
       if newwidth ~= width or newheight ~= height then
               newwidth, newheight = width, height;  
       if width >=1280 then             
               panel3Frame:attach(screenBox, (width-panel3FrameWidth)/2-161, 3, (width-panel3FrameWidth)/2+161, height-panel3FrameHeight-3)    
       else
          if width>=900  then
             panel3Frame:attach(screenBox, 195, 3, width-panel3FrameWidth-195, height-panel3FrameHeight-3)
          else
             panel3Frame:attach(screenBox, 6, 3, width-panel3FrameWidth-6, height-panel3FrameHeight-3)
          end
       end
    end
end;
--======================================
-- Подключение команд 
--======================================

--...............................................................

-- ===================
-- sepAngles - Угломер
-- ===================
-- require "sepAngles_config"
----------------------------------------------
-- Set initial values
----------------------------------------------

local sx, sy = celestia:getscreendimension()
local lspace = normalfont:getheight() + 1
local boxW, boxH = 120,lspace * 2  -- display width = 120 pixels, display height = 2 lines
local posX, posT = 0, 170  -- near the left margin, 170 pixels from the top of the screen.

local sel1, sel2 = nil, nil -- no object selected

local renderflags = celestia:getrenderflags()
renderflags["markers"] = true
celestia:setrenderflags(renderflags)

-- personalization
local display_angle = sepAngles_visible or false
local textcolor = sepAngles_color or {0.7, 0.7, 1, 0.9}
local shortcut = sepAngles_shortcut or "A"

----------------------------------------------
-- local functions
----------------------------------------------

local getnewselection = function()
   local obj = celestia:getselection()
   -- test if there is a new selection
   local sel = true  
   if obj:type() == "null" then
      sel = false
   elseif sel2 and sel2:name() == obj:name() then
      sel = false
   elseif sel1 and sel1:name() == obj:name() then 
      sel = false
   end
   
    -- record and mark selection
   if sel then
      if sel2 then 
         sel1:unmark(); sel2:unmark()
         sel1=obj; sel2 = nil
         sel1:mark()
      elseif sel1 then
         sel2=obj; sel2:mark()
      else
         sel1=obj; sel1:mark()
      end
   end
end

local angle = function()
   if sel1 and sel2 then
      local obs = celestia:getobserver()
      local a= sel1:getposition() - obs:getposition()
      local b= sel2:getposition() - obs:getposition()
      local sepangle = math.acos(a:normalize() * b:normalize())*180/math.pi
      return string.format(" %0.2f°",sepangle)
   else
      return "- - - - - -"
   end
end
--===================
sepAnglesButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(1, 7)  
    :text(_("Sep.angles"))         
    :movable(false)
    :active(true)
    :attach( panel3Frame, 64, 2+17*(gg-5), 64, 3+17*5)

sepAnglesCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-5, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel3Frame, 64+2, 2+17*(gg-5), 64+50, 3+17*5)

sepAnglesButton.Action = (function()
        return
            function()
              display_sepAngles = not display_sepAngles;
                if display_sepAngles then
                  --  celestia:show("ecliptic") 
                    sepAnglesCheck.Text = "|";
                else 
                     celestia:hide("ecliptic") 
                    sepAnglesCheck.Text = "";
                end
            end

        end) ();

sepAnglesFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :textfont(normalfont)
    :textcolor(textcolor)
    :text("Angular separation")
    :movetext(-5,4)
    :movable(false)
    :clickable(true)
    :visible(display_angle)
    :attach(screenBox, posX, sy-posT-boxH, sx-boxW-posX, posT)
 --[[  
sepAnglesFrame.Customdraw = function(this)
   getnewselection()
   
   textlayout:setfont(normalfont)
   textlayout:setfontcolor(textcolor)
   textlayout:setlinespacing(lspace)
   textlayout:setpos(this.lb,this.tb-lspace*2+2) -- second line of the box
   textlayout:println(angle())

   sx, sy = celestia:getscreendimension()
   sepAnglesFrame:attach(screenBox, posX, sy-posT-boxH, sx-boxW-posX, posT)
end

local toggleAnglesDisplay = function()
   sepAnglesFrame.Visible = not sepAnglesFrame.Visible
   celestia:unmarkall()
   sel1=nil
   sel2=nil
end
]]

--[[
-- activation
--if lua_edu_tools then  -- activate with mouse
   sepAnglesCheck.Action = function(this)
      toggleAnglesDisplay()
      if sepAnglesFrame.Visible then
         this:text("x")
      else
         this:text("")
      end
   end

else -- Lua Plug-ins: activate with keyboard
   keymap[shortcut] = toggleAnglesDisplay
end

]]

